---
title: '::file-selector-button'
slug: 'Web/CSS/::file-selector-button'
tags:
  - CSS
  - Non-standard
  - Pseudo-element
  - Reference
  - Selector
  - WebKit
---
<div>{{CSSRef}}</div>

<p>The <strong><code>::file-selector-button</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-elements">pseudo-element</a> represents the button of an {{HTMLElement("input") }} of  <code><a href="/en-US/docs/Web/HTML/Element/input/file">type="file"</a></code>.</p>

<div class="notecard note">
<p>WebKit/Blink compatible browsers like Chrome, Opera and Safari (indicated by the <code>-webkit</code> prefix) support a non-standard pseudo-class <code>::-webkit-file-upload-button</code> which serves the same purpose.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>selector</var>::file-selector-button
</pre>

<h2 id="Examples">Examples</h2>

<div id="basic_example">
<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;label for="fileUpload"&gt;Upload file&lt;/label&gt;
  &lt;input type="file" id="fileUpload"&gt;
&lt;/form&gt;</pre>

<h3 id="CSS">CSS</h3>

<div class="hidden">
<pre class="brush: css notranslate">form {
  display: flex;
  gap: 1em;
  align-items: center;
}
</pre>
</div>

<pre class="brush: css notranslate">input[type=file]::file-selector-button {
  border: 2px solid #6c5ce7;
  padding: .2em .4em;
  border-radius: .2em;
  background-color: #a29bfe;
  transition: 1s;
}

input[type=file]::file-selector-button:hover {
  background-color: #81ecec;
  border: 2px solid #00cec9;
}
</pre>
</div>

<p>{{EmbedLiveSample("basic_example", "100%", 150)}}</p>

<p>Example with fallback for browsers supporting the <code>-webkit</code> prefix. Note that as a selector you will need to write out the whole code block twice, as an unrecognized selector invalidates the whole list.</p>

<p>Note that <code>::file-selector-button</code> is a whole element, and as such matches the rules from the UA stylesheet. In particular, fonts and colors won't necessarily inherit from the <code>input</code> element.</p>

<div id="fallback_example">
<h3 id="HTML_2">HTML</h3>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;label for="fileUpload"&gt;Upload file&lt;/label&gt;
  &lt;input type="file" id="fileUpload"&gt;
&lt;/form&gt;</pre>

<h3 id="CSS_2">CSS</h3>

<div class="hidden">
<pre class="brush: css notranslate">form {
  display: flex;
  gap: 1em;
  align-items: center;
}
</pre>
</div>

<pre class="brush: css notranslate">input[type=file]::-webkit-file-upload-button {
  border: 2px solid #6c5ce7;
  padding: .2em .4em;
  border-radius: .2em;
  background-color: #a29bfe;
  transition: 1s;
}

input[type=file]::file-selector-button {
  border: 2px solid #6c5ce7;
  padding: .2em .4em;
  border-radius: .2em;
  background-color: #a29bfe;
  transition: 1s;
}

input[type=file]::-webkit-file-upload-button:hover {
  background-color: #81ecec;
  border: 2px solid #00cec9;
}

input[type=file]::file-selector-button:hover {
  background-color: #81ecec;
  border: 2px solid #00cec9;
}
</pre>
</div>

<p>{{EmbedLiveSample("fallback_example", "100%", 150)}}</p>

<h2 id="Specifications">Specifications</h2>

<p>The pseudo-element <a href="https://github.com/w3c/csswg-drafts/issues/5049#issuecomment-666449792">has been resolved on by the CSS WG</a> however the edit has not yet been made in a specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.file-selector-button")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/WebKit_Extensions">WebKit CSS extensions</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Firefox_support">File and Directory Entries API support in Firefox</a></li>
 <li><code><a href="/en-US/docs/Web/HTML/Element/input/file">&lt;input type="file"&gt;</a></code></li>
</ul>
